Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.persistence.query
Class ExpressionImpl

    java.lang.Object
      org.apache.openjpa.persistence.query.AbstractVisitable
          org.apache.openjpa.persistence.query.ExpressionImpl

All Implemented Interfaces:
  Serializable, Expression, OrderByItem, PredicateOperand, SelectItem, Visitable

Direct Known Subclasses:
  AbstractPath, ArrayExpression, BinaryOperatorExpression, ConstantExpression, CurrentTimeExpression, ElseExpression, ParameterExpression, QueryDefinitionImpl, UnaryOperatorExpression, VarArgsExpression

    abstract class ExpressionImpl

extends AbstractVisitable
implements Expression, Visitable

An abstract expression acts as a factory for concrete unary or binary expressions such as ABS() or PLUS().

Author:
  Pinaki Poddar

Field Summary

Fields inherited from class org.apache.openjpa.persistence.query.AbstractVisitable
`CLOSE_BRACE, COMMA, EMPTY, OPEN_BRACE, SPACE`

Constructor Summary
`ExpressionImpl()`

Method Summary
`Expression` | `abs()` Absolute value.
`OrderByItem` | `asc()` Return an OrderByItem referencing the SelectItem and specifying ascending ordering.
`Predicate` | `between(Calendar arg1, Calendar arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(Calendar arg1, PredicateOperand arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(Date arg1, Date arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(Date arg1, PredicateOperand arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(Number arg1, Number arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(Number arg1, PredicateOperand arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(PredicateOperand arg1, Calendar arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(PredicateOperand arg1, Date arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(PredicateOperand arg1, Number arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(PredicateOperand arg1, PredicateOperand arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(PredicateOperand arg1, String arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(String arg1, PredicateOperand arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Predicate` | `between(String arg1, String arg2)` Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.
`Expression` | `concat(Expression... exprs)` Concatenate a string with other string(s).
`Expression` | `concat(String... str)` Concatenate a string with other string(s).
`OrderByItem` | `desc()` Return an OrderByItem referencing the SelectItem and specifying descending ordering.
`Expression` | `dividedBy(Expression expr)` Division.
`Expression` | `dividedBy(Number num)` Division.
`Predicate` | `equal(boolean arg)` Create a predicate for testing equality with the specified argument.
`Predicate` | `equal(Calendar arg)` Create a predicate for testing equality with the specified argument.
`Predicate` | `equal(Class cls)` Create a predicate for testing equality with the specified argument.
`Predicate` | `equal(Date arg)` Create a predicate for testing equality with the specified argument.
`Predicate` | `equal(Enum<?> e)` Create a predicate for testing equality with the specified argument.
`Predicate` | `equal(Number arg)` Create a predicate for testing equality with the specified argument.
`Predicate` | `equal(PredicateOperand arg)` Create a predicate for testing equality with the specified argument.
`Predicate` | `equal(String arg)` Create a predicate for testing equality with the specified argument.
`String` | `getAliasHint(AliasContext ctx)` Gets the hint to be used while creating alias.
`Predicate` | `greaterEqual(Calendar arg)` Create a predicate for testing whether the PredicateOperand is greater than or equal to the argument.
`Predicate` | `greaterEqual(Date arg)` Create a predicate for testing whether the PredicateOperand is greater than or equal to the argument.
`Predicate` | `greaterEqual(Number arg)` Create a predicate for testing whether the PredicateOperand is greater than or equal to the argument.
`Predicate` | `greaterEqual(PredicateOperand arg)` Create a predicate for testing whether the PredicateOperand is greater than or equal to the argument.
`Predicate` | `greaterEqual(String arg)` Create a predicate for testing whether the PredicateOperand is greater than or equal to the argument.
`Predicate` | `greaterThan(Calendar arg)` Create a predicate for testing whether the PredicateOperand is greater than the argument.
`Predicate` | `greaterThan(Date arg)` Create a predicate for testing whether the PredicateOperand is greater than the argument.
`Predicate` | `greaterThan(Number arg)` Create a predicate for testing whether the PredicateOperand is greater than the argument.
`Predicate` | `greaterThan(PredicateOperand arg)` Create a predicate for testing whether the PredicateOperand is greater than the argument.
`Predicate` | `greaterThan(String arg)` Create a predicate for testing whether the PredicateOperand is greater than the argument.
`Predicate` | `in(Class... classes)` Create a predicate for testing whether the expression value is a member of the argument list.
`Predicate` | `in(Enum<?>... enums)` Create a predicate for testing whether the expression value is a member of the argument list.
`Predicate` | `in(Expression... params)` Create a predicate for testing whether the expression value is a member of the argument list.
`Predicate` | `in(Number... nums)` Create a predicate for testing whether the expression value is a member of the argument list.
`Predicate` | `in(String... strings)` Create a predicate for testing whether the expression value is a member of the argument list.
`Predicate` | `in(Subquery subquery)` Create a predicate for testing whether the expression value is a member of a subquery result.
`Predicate` | `isNull()` Create a predicate for testing whether the value of the expression is null.
`Expression` | `length()` String length This method must be invoked on an expression corresponding to a string.
`Predicate` | `lessEqual(Calendar arg)` Create a predicate for testing whether the PredicateOperand is less than or equal to the argument.
`Predicate` | `lessEqual(Date arg)` Create a predicate for testing whether the PredicateOperand is less than or equal to the argument.
`Predicate` | `lessEqual(Number arg)` Create a predicate for testing whether the PredicateOperand is less than or equal to the argument.
`Predicate` | `lessEqual(PredicateOperand arg)` Create a predicate for testing whether the PredicateOperand is less than or equal to the argument.
`Predicate` | `lessEqual(String arg)` Create a predicate for testing whether the PredicateOperand is less than or equal to the argument.
`Predicate` | `lessThan(Calendar arg)` Create a predicate for testing whether the PredicateOperand is less than the argument.
`Predicate` | `lessThan(Date arg)` Create a predicate for testing whether the PredicateOperand is less than the argument.
`Predicate` | `lessThan(Number arg)` Create a predicate for testing whether the PredicateOperand is less than the argument.
`Predicate` | `lessThan(PredicateOperand arg)` Create a predicate for testing whether the PredicateOperand is less than the argument.
`Predicate` | `lessThan(String arg)` Create a predicate for testing whether the PredicateOperand is less than the argument.
`Predicate` | `like(PredicateOperand pattern)` Create a predicate for testing whether the PredicateOperand satisfies the given pattern.
`Predicate` | `like(PredicateOperand pattern, char escapeChar)` Create a predicate for testing whether the PredicateOperand satisfies the given pattern.
`Predicate` | `like(PredicateOperand pattern, PredicateOperand escChar)` Create a predicate for testing whether the PredicateOperand satisfies the given pattern.
`Predicate` | `like(String pattern)` Create a predicate for testing whether the PredicateOperand satisfies the given pattern.
`Predicate` | `like(String pattern, char escChar)` Create a predicate for testing whether the PredicateOperand satisfies the given pattern.
`Predicate` | `like(String pattern, PredicateOperand escapeChar)` Create a predicate for testing whether the PredicateOperand satisfies the given pattern.
`Expression` | `locate(Expression expr)` Locate a string contained within the string corresponding to the expression on which the method was invoked.
`Expression` | `locate(Expression str, Expression position)` Locate a string contained within the string corresponding to the expression on which the method was invoked, starting at a specified search position.
`Expression` | `locate(Expression str, int position)` Locate a string contained within the string corresponding to the expression on which the method was invoked, starting at a specified search position.
`Expression` | `locate(String str)` Locate a string contained within the string corresponding to the expression on which the method was invoked.
`Expression` | `locate(String str, Expression position)` Locate a string contained within the string corresponding to the expression on which the method was invoked, starting at a specified search position.
`Expression` | `locate(String str, int position)` Locate a string contained within the string corresponding to the expression on which the method was invoked, starting at a specified search position.
`Expression` | `lower()` Convert string to lowercase.
`Predicate` | `member(PathExpression arg)` Create a predicate for testing whether the expression is a member of the association or element collection denoted by the path expression.
`Expression` | `minus()` Unary minus.
`Expression` | `minus(Expression expr)` Subtraction.
`Expression` | `minus(Number num)` Subtraction.
`Expression` | `mod(Expression expr)` Modulo operation.
`Expression` | `mod(int num)` Modulo operation.
`Predicate` | `notEqual(boolean arg)` Create a predicate for testing inequality with the specified argument.
`Predicate` | `notEqual(Calendar arg)` Create a predicate for testing inequality with the specified argument.
`Predicate` | `notEqual(Class cls)` Create a predicate for testing inequality with the specified argument.
`Predicate` | `notEqual(Date arg)` Create a predicate for testing inequality with the specified argument.
`Predicate` | `notEqual(Enum<?> e)` Create a predicate for testing inequality with the specified argument.
`Predicate` | `notEqual(Number arg)` Create a predicate for testing inequality with the specified argument.
`Predicate` | `notEqual(PredicateOperand arg)` Create a predicate for testing inequality with the specified argument.
`Predicate` | `notEqual(String arg)` Create a predicate for testing inequality with the specified argument.
`Expression` | `plus(Expression expr)` Addition.
`Expression` | `plus(Number num)` Addition.
`Expression` | `sqrt()` Square root.
`Expression` | `substring(Expression start)` Extract a substring starting at specified position through to the end of the string.
`Expression` | `substring(Expression start, Expression len)` Extract a substring.
`Expression` | `substring(Expression start, int len)` Extract a substring.
`Expression` | `substring(int start)` Extract a substring starting at specified position through to the end of the string.
`Expression` | `substring(int start, Expression len)` Extract a substring.
`Expression` | `substring(int start, int len)` Extract a substring.
`Expression` | `times(Expression expr)` Multiplication.
`Expression` | `times(Number num)` Multiplication.
`Expression` | `trim()` Trim leading and trailing blanks.
`Expression` | `trim(char c)` Trim leading and trailing occurrences of character from the string.
`Expression` | `trim(char c, TrimSpec spec)` Trim occurrences of the character from leading or trailing (or both) positions of the string, as specified by trim spec.
`Expression` | `trim(Expression expr)` Trim leading and trailing occurrences of character specified by the expression argument from the string.
`Expression` | `trim(Expression expr, TrimSpec spec)` Trim occurrences of the character specified by the expression argument from leading or trailing (or both) positions of the string, as specified by trim spec.
`Expression` | `trim(TrimSpec spec)` Trim leading, trailing blanks (or both) as specified by trim spec.
`Expression` | `upper()` Convert string to uppercase.

Methods inherited from class org.apache.openjpa.persistence.query.AbstractVisitable
`asExpression, asJoinable, asProjection`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.openjpa.persistence.query.Visitable
`asExpression, asJoinable, asProjection`

Constructor Detail

### ExpressionImpl

    ExpressionImpl()

Method Detail

### abs

    public Expression abs()

  Description copied from interface: `Expression`
  Absolute value. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `abs` in interface `Expression`
  Returns:
    expression corresponding to the absolute value

### concat

    public Expression concat(String... str)

  Description copied from interface: `Expression`
  Concatenate a string with other string(s). This method must be invoked on an expression corresponding to a string.

  Specified by:
    `concat` in interface `Expression`
  Parameters:
    `str` - - string(s)
  Returns:
    expression denoting the concatenation of the strings, starting with the string corresponding to the expression on which the method was invoked.

### concat

    public Expression concat(Expression... exprs)

  Description copied from interface: `Expression`
  Concatenate a string with other string(s). This method must be invoked on an expression corresponding to a string.

  Specified by:
    `concat` in interface `Expression`
  Parameters:
    `exprs` - - expression(s) corresponding to string(s)
  Returns:
    expression denoting the concatenation of the strings, starting with the string corresponding to the expression on which the method was invoked.

### dividedBy

    public Expression dividedBy(Number num)

  Description copied from interface: `Expression`
  Division. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `dividedBy` in interface `Expression`
  Parameters:
    `num` - - divisor
  Returns:
    expression denoting the result of dividing the number corresponding to the expression on which the method was invoked by the argument

### dividedBy

    public Expression dividedBy(Expression expr)

  Description copied from interface: `Expression`
  Division. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `dividedBy` in interface `Expression`
  Parameters:
    `expr` - - expression corresponding to the divisor
  Returns:
    expression denoting the result of dividing the number corresponding to the expression on which the method was invoked by the number denoted by the argument

### in

    public Predicate in(String... strings)

  Description copied from interface: `Expression`
  Create a predicate for testing whether the expression value is a member of the argument list.

  Specified by:
    `in` in interface `Expression`
  Returns:
    conditional predicate

### in

    public Predicate in(Number... nums)

  Description copied from interface: `Expression`
  Create a predicate for testing whether the expression value is a member of the argument list.

  Specified by:
    `in` in interface `Expression`
  Returns:
    conditional predicate

### in

    public Predicate in(Enum<?>... enums)

  Description copied from interface: `Expression`
  Create a predicate for testing whether the expression value is a member of the argument list.

  Specified by:
    `in` in interface `Expression`
  Returns:
    conditional predicate

### in

    public Predicate in(Class... classes)

  Description copied from interface: `Expression`
  Create a predicate for testing whether the expression value is a member of the argument list.

  Specified by:
    `in` in interface `Expression`
  Returns:
    conditional predicate

### in

    public Predicate in(Expression... params)

  Description copied from interface: `Expression`
  Create a predicate for testing whether the expression value is a member of the argument list.

  Specified by:
    `in` in interface `Expression`
  Returns:
    conditional predicate

### in

    public Predicate in(Subquery subquery)

  Description copied from interface: `Expression`
  Create a predicate for testing whether the expression value is a member of a subquery result.

  Specified by:
    `in` in interface `Expression`
  Returns:
    conditional predicate

### isNull

    public Predicate isNull()

  Description copied from interface: `Expression`
  Create a predicate for testing whether the value of the expression is null.

  Specified by:
    `isNull` in interface `Expression`
  Returns:
    conditional predicate

### length

    public Expression length()

  Description copied from interface: `Expression`
  String length This method must be invoked on an expression corresponding to a string.

  Specified by:
    `length` in interface `Expression`
  Returns:
    expression denoting the length of the string.

### locate

    public Expression locate(String str)

  Description copied from interface: `Expression`
  Locate a string contained within the string corresponding to the expression on which the method was invoked. The search is started at position 1 (first string position). This method must be invoked on an expression corresponding to a string.

  Specified by:
    `locate` in interface `Expression`
  Parameters:
    `str` - - string to be located
  Returns:
    expression denoting the first position at which the string was found or expression denoting 0 if the string was not found

### locate

    public Expression locate(Expression expr)

  Description copied from interface: `Expression`
  Locate a string contained within the string corresponding to the expression on which the method was invoked. The search is started at position 1 (first string position). This method must be invoked on an expression corresponding to a string.

  Specified by:
    `locate` in interface `Expression`
  Parameters:
    `expr` - - expression corresponding to the string to be located
  Returns:
    expression denoting the first position at which the string was found or expression denoting 0 if the string was not found

### locate

    public Expression locate(String str,
                             int position)

  Description copied from interface: `Expression`
  Locate a string contained within the string corresponding to the expression on which the method was invoked, starting at a specified search position. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `locate` in interface `Expression`
  Parameters:
    `str` - - string to be located
    `position` - - position at which to start the search
  Returns:
    expression denoting the first position at which the string was found or expression denoting 0 if the string was not found

### locate

    public Expression locate(String str,
                             Expression position)

  Description copied from interface: `Expression`
  Locate a string contained within the string corresponding to the expression on which the method was invoked, starting at a specified search position. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `locate` in interface `Expression`
  Parameters:
    `str` - - string to be located
    `position` - - expression corresponding to position at which to start the search
  Returns:
    expression denoting the first position at which the string was found or expression denoting 0 if the string was not found

### locate

    public Expression locate(Expression str,
                             int position)

  Description copied from interface: `Expression`
  Locate a string contained within the string corresponding to the expression on which the method was invoked, starting at a specified search position. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `locate` in interface `Expression`
  Parameters:
    `str` - - expression corresponding to the string to be located
    `position` - - position at which to start the search
  Returns:
    expression denoting the first position at which the string was found or expression denoting 0 if the string was not found

### locate

    public Expression locate(Expression str,
                             Expression position)

  Description copied from interface: `Expression`
  Locate a string contained within the string corresponding to the expression on which the method was invoked, starting at a specified search position. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `locate` in interface `Expression`
  Parameters:
    `str` - - expression corresponding to the string to be located
    `position` - - expression corresponding to position at which to start the search
  Returns:
    expression denoting the first position at which the string was found or expression denoting 0 if the string was not found

### lower

    public Expression lower()

  Description copied from interface: `Expression`
  Convert string to lowercase. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `lower` in interface `Expression`
  Returns:
    expression denoting the string in lowercase

### member

    public Predicate member(PathExpression arg)

  Description copied from interface: `Expression`
  Create a predicate for testing whether the expression is a member of the association or element collection denoted by the path expression. The argument must correspond to a collection-valued association or element collection of like type.

  Specified by:
    `member` in interface `Expression`
  Parameters:
    `arg` - - a path expression that specifies a collection-valued association or an element collection
  Returns:
    conditional predicate

### minus

    public Expression minus()

  Description copied from interface: `Expression`
  Unary minus. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `minus` in interface `Expression`
  Returns:
    expression denoting the unary minus of the expression

### minus

    public Expression minus(Number num)

  Description copied from interface: `Expression`
  Subtraction. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `minus` in interface `Expression`
  Parameters:
    `num` - - subtrahend
  Returns:
    expression denoting the result of subtracting the argument from the number corresponding to the expression on which the method was invoked.

### minus

    public Expression minus(Expression expr)

  Description copied from interface: `Expression`
  Subtraction. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `minus` in interface `Expression`
  Parameters:
    `expr` - - expression corresponding to subtrahend
  Returns:
    expression denoting the result of subtracting the number denoted by the argument from the number corresponding to the expression on which the method was invoked.

### mod

    public Expression mod(int num)

  Description copied from interface: `Expression`
  Modulo operation. This must be invoked on an expression corresponding to an integer value

  Specified by:
    `mod` in interface `Expression`
  Parameters:
    `num` - - integer divisor
  Returns:
    expression corresponding to the integer remainder of the division of the integer corresponding to the expression on which the method was invoked by the argument.

### mod

    public Expression mod(Expression expr)

  Description copied from interface: `Expression`
  Modulo operation. This must be invoked on an expression corresponding to an integer value

  Specified by:
    `mod` in interface `Expression`
  Parameters:
    `expr` - - expression corresponding to integer divisor
  Returns:
    expression corresponding to the integer remainder of the division of the integer corresponding to the expression on which the method was invoked by the argument.

### plus

    public Expression plus(Number num)

  Description copied from interface: `Expression`
  Addition. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `plus` in interface `Expression`
  Parameters:
    `num` - - number to be added
  Returns:
    expression denoting the sum

### plus

    public Expression plus(Expression expr)

  Description copied from interface: `Expression`
  Addition. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `plus` in interface `Expression`
  Parameters:
    `expr` - - expression corresponding to number to be added
  Returns:
    expression denoting the sum

### sqrt

    public Expression sqrt()

  Description copied from interface: `Expression`
  Square root. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `sqrt` in interface `Expression`
  Returns:
    expression corresponding to the square root

### substring

    public Expression substring(int start)

  Description copied from interface: `Expression`
  Extract a substring starting at specified position through to the end of the string. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `substring` in interface `Expression`
  Parameters:
    `start` - - start position (1 indicates first position)
  Returns:
    expression denoting the extracted substring

### substring

    public Expression substring(Expression start)

  Description copied from interface: `Expression`
  Extract a substring starting at specified position through to the end of the string. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `substring` in interface `Expression`
  Parameters:
    `start` - - expression denoting start position (1 indicates first position)
  Returns:
    expression denoting the extracted substring

### substring

    public Expression substring(int start,
                                int len)

  Description copied from interface: `Expression`
  Extract a substring. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `substring` in interface `Expression`
  Parameters:
    `start` - - start position (1 indicates first position)
    `len` - - length of the substring to be returned
  Returns:
    expression denoting the extracted substring

### substring

    public Expression substring(int start,
                                Expression len)

  Description copied from interface: `Expression`
  Extract a substring. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `substring` in interface `Expression`
  Parameters:
    `start` - - start position (1 indicates first position)
    `len` - - expression denoting length of the substring to return
  Returns:
    expression denoting the extracted substring

### substring

    public Expression substring(Expression start,
                                int len)

  Description copied from interface: `Expression`
  Extract a substring. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `substring` in interface `Expression`
  Parameters:
    `start` - - expression denoting start position (1 indicates first position)
    `len` - - length of the substring to return
  Returns:
    expression denoting the extracted substring

### substring

    public Expression substring(Expression start,
                                Expression len)

  Description copied from interface: `Expression`
  Extract a substring. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `substring` in interface `Expression`
  Parameters:
    `start` - - expression denoting start position (1 indicates first position)
    `len` - - expression denoting length of the substring to return
  Returns:
    expression denoting the extracted substring

### times

    public Expression times(Number num)

  Description copied from interface: `Expression`
  Multiplication. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `times` in interface `Expression`
  Parameters:
    `num` - - multiplier
  Returns:
    expression denoting the result of multiplying the argument with the number corresponding to the expression on which the method was invoked.

### times

    public Expression times(Expression expr)

  Description copied from interface: `Expression`
  Multiplication. This method must be invoked on an expression corresponding to a number.

  Specified by:
    `times` in interface `Expression`
  Parameters:
    `expr` - - expression corresponding to the multiplier
  Returns:
    expression denoting the result of multiplying the number denoted by the argument with the number corresponding to the expression on which the method was invoked.

### trim

    public Expression trim()

  Description copied from interface: `Expression`
  Trim leading and trailing blanks. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `trim` in interface `Expression`
  Returns:
    expression denoting trimmed string

### trim

    public Expression trim(TrimSpec spec)

  Description copied from interface: `Expression`
  Trim leading, trailing blanks (or both) as specified by trim spec. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `trim` in interface `Expression`
  Parameters:
    `spec` - - trim specification
  Returns:
    expression denoting trimmed string

### trim

    public Expression trim(char c)

  Description copied from interface: `Expression`
  Trim leading and trailing occurrences of character from the string. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `trim` in interface `Expression`
  Parameters:
    `c` - - character to be trimmed
  Returns:
    expression denoting trimmed string

### trim

    public Expression trim(char c,
                           TrimSpec spec)

  Description copied from interface: `Expression`
  Trim occurrences of the character from leading or trailing (or both) positions of the string, as specified by trim spec. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `trim` in interface `Expression`
  Parameters:
    `c` - - character to be trimmed
    `spec` - - trim specification
  Returns:
    expression denoting trimmed string

### trim

    public Expression trim(Expression expr)

  Description copied from interface: `Expression`
  Trim leading and trailing occurrences of character specified by the expression argument from the string. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `trim` in interface `Expression`
  Parameters:
    `expr` - - expression corresponding to the character to be trimmed
  Returns:
    expression denoting trimmed string

### trim

    public Expression trim(Expression expr,
                           TrimSpec spec)

  Description copied from interface: `Expression`
  Trim occurrences of the character specified by the expression argument from leading or trailing (or both) positions of the string, as specified by trim spec. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `trim` in interface `Expression`
  Parameters:
    `expr` - - expression corresponding to the character to be trimmed
    `spec` - - trim specification
  Returns:
    expression denoting trimmed string

### upper

    public Expression upper()

  Description copied from interface: `Expression`
  Convert string to uppercase. This method must be invoked on an expression corresponding to a string.

  Specified by:
    `upper` in interface `Expression`
  Returns:
    expression denoting the string in uppercase

### asc

    public OrderByItem asc()

  Description copied from interface: `SelectItem`
  Return an OrderByItem referencing the SelectItem and specifying ascending ordering. The SelectItem must correspond to an orderable value.

  Specified by:
    `asc` in interface `SelectItem`
  Returns:
    order-by item

### desc

    public OrderByItem desc()

  Description copied from interface: `SelectItem`
  Return an OrderByItem referencing the SelectItem and specifying descending ordering. The SelectItem must correspond to an orderable value.

  Specified by:
    `desc` in interface `SelectItem`
  Returns:
    order-by item

### between

    public Predicate between(PredicateOperand arg1,
                             PredicateOperand arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - PredicateOperand instance or parameter
    `arg2` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### between

    public Predicate between(PredicateOperand arg1,
                             Number arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - PredicateOperand instance or parameter
    `arg2` - - numeric
  Returns:
    conditional predicate

### between

    public Predicate between(Number arg1,
                             PredicateOperand arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - numeric
    `arg2` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### between

    public Predicate between(Number arg1,
                             Number arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - numeric
    `arg2` - - numeric
  Returns:
    conditional predicate

### between

    public Predicate between(PredicateOperand arg1,
                             String arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - PredicateOperand instance or parameter
    `arg2` - - string
  Returns:
    conditional predicate

### between

    public Predicate between(String arg1,
                             PredicateOperand arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - string
    `arg2` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### between

    public Predicate between(String arg1,
                             String arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - string
    `arg2` - - string
  Returns:
    conditional predicate

### between

    public Predicate between(PredicateOperand arg1,
                             Date arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - PredicateOperand instance or parameter
    `arg2` - - date
  Returns:
    conditional predicate

### between

    public Predicate between(Date arg1,
                             PredicateOperand arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - date
    `arg2` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### between

    public Predicate between(Date arg1,
                             Date arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - date
    `arg2` - - date
  Returns:
    conditional predicate

### between

    public Predicate between(PredicateOperand arg1,
                             Calendar arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - PredicateOperand instance or parameter
    `arg2` - - calendar
  Returns:
    conditional predicate

### between

    public Predicate between(Calendar arg1,
                             PredicateOperand arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - calendar
    `arg2` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### between

    public Predicate between(Calendar arg1,
                             Calendar arg2)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand lies between (inclusive) the two arguments.

  Specified by:
    `between` in interface `PredicateOperand`
  Parameters:
    `arg1` - - calendar
    `arg2` - - calendar
  Returns:
    conditional predicate

### equal

    public Predicate equal(PredicateOperand arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing equality with the specified argument.

  Specified by:
    `equal` in interface `PredicateOperand`
  Parameters:
    `arg` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### equal

    public Predicate equal(Class cls)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing equality with the specified argument.

  Specified by:
    `equal` in interface `PredicateOperand`
  Parameters:
    `cls` - - entity class
  Returns:
    conditional predicate

### equal

    public Predicate equal(Number arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing equality with the specified argument.

  Specified by:
    `equal` in interface `PredicateOperand`
  Parameters:
    `arg` - - numeric
  Returns:
    conditional predicate

### equal

    public Predicate equal(String arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing equality with the specified argument.

  Specified by:
    `equal` in interface `PredicateOperand`
  Parameters:
    `arg` - - string value
  Returns:
    conditional predicate

### equal

    public Predicate equal(boolean arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing equality with the specified argument.

  Specified by:
    `equal` in interface `PredicateOperand`
  Parameters:
    `arg` - - boolean value
  Returns:
    conditional predicate

### equal

    public Predicate equal(Date arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing equality with the specified argument.

  Specified by:
    `equal` in interface `PredicateOperand`
  Parameters:
    `arg` - - date
  Returns:
    conditional predicate

### equal

    public Predicate equal(Calendar arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing equality with the specified argument.

  Specified by:
    `equal` in interface `PredicateOperand`
  Parameters:
    `arg` - - calendar
  Returns:
    conditional predicate

### equal

    public Predicate equal(Enum<?> e)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing equality with the specified argument.

  Specified by:
    `equal` in interface `PredicateOperand`
  Parameters:
    `e` - - enum
  Returns:
    conditional predicate

### greaterEqual

    public Predicate greaterEqual(PredicateOperand arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is greater than or equal to the argument.

  Specified by:
    `greaterEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### greaterEqual

    public Predicate greaterEqual(Number arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is greater than or equal to the argument.

  Specified by:
    `greaterEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - numeric
  Returns:
    conditional predicate

### greaterEqual

    public Predicate greaterEqual(String arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is greater than or equal to the argument.

  Specified by:
    `greaterEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - string
  Returns:
    conditional predicate

### greaterEqual

    public Predicate greaterEqual(Date arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is greater than or equal to the argument.

  Specified by:
    `greaterEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - date
  Returns:
    conditional predicate

### greaterEqual

    public Predicate greaterEqual(Calendar arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is greater than or equal to the argument.

  Specified by:
    `greaterEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - calendar
  Returns:
    conditional predicate

### greaterThan

    public Predicate greaterThan(PredicateOperand arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is greater than the argument.

  Specified by:
    `greaterThan` in interface `PredicateOperand`
  Parameters:
    `arg` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### greaterThan

    public Predicate greaterThan(Number arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is greater than the argument.

  Specified by:
    `greaterThan` in interface `PredicateOperand`
  Parameters:
    `arg` - - numeric
  Returns:
    conditional predicate

### greaterThan

    public Predicate greaterThan(String arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is greater than the argument.

  Specified by:
    `greaterThan` in interface `PredicateOperand`
  Parameters:
    `arg` - - string
  Returns:
    conditional predicate

### greaterThan

    public Predicate greaterThan(Date arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is greater than the argument.

  Specified by:
    `greaterThan` in interface `PredicateOperand`
  Parameters:
    `arg` - - date
  Returns:
    conditional predicate

### greaterThan

    public Predicate greaterThan(Calendar arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is greater than the argument.

  Specified by:
    `greaterThan` in interface `PredicateOperand`
  Parameters:
    `arg` - - calendar
  Returns:
    conditional predicate

### lessEqual

    public Predicate lessEqual(PredicateOperand arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is less than or equal to the argument.

  Specified by:
    `lessEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### lessEqual

    public Predicate lessEqual(Number arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is less than or equal to the argument.

  Specified by:
    `lessEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - numeric
  Returns:
    conditional predicate

### lessEqual

    public Predicate lessEqual(String arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is less than or equal to the argument.

  Specified by:
    `lessEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - string
  Returns:
    conditional predicate

### lessEqual

    public Predicate lessEqual(Date arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is less than or equal to the argument.

  Specified by:
    `lessEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - date
  Returns:
    conditional predicate

### lessEqual

    public Predicate lessEqual(Calendar arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is less than or equal to the argument.

  Specified by:
    `lessEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - calendar
  Returns:
    conditional predicate

### lessThan

    public Predicate lessThan(PredicateOperand arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is less than the argument.

  Specified by:
    `lessThan` in interface `PredicateOperand`
  Parameters:
    `arg` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### lessThan

    public Predicate lessThan(Number arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is less than the argument.

  Specified by:
    `lessThan` in interface `PredicateOperand`
  Parameters:
    `arg` - - numeric
  Returns:
    conditional predicate

### lessThan

    public Predicate lessThan(String arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is less than the argument.

  Specified by:
    `lessThan` in interface `PredicateOperand`
  Parameters:
    `arg` - - string
  Returns:
    conditional predicate

### lessThan

    public Predicate lessThan(Date arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is less than the argument.

  Specified by:
    `lessThan` in interface `PredicateOperand`
  Parameters:
    `arg` - - date
  Returns:
    conditional predicate

### lessThan

    public Predicate lessThan(Calendar arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand is less than the argument.

  Specified by:
    `lessThan` in interface `PredicateOperand`
  Parameters:
    `arg` - - calendar
  Returns:
    conditional predicate

### like

    public Predicate like(PredicateOperand pattern)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand satisfies the given pattern.

  Specified by:
    `like` in interface `PredicateOperand`
  Returns:
    conditional predicate

### like

    public Predicate like(PredicateOperand pattern,
                          PredicateOperand escChar)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand satisfies the given pattern.

  Specified by:
    `like` in interface `PredicateOperand`
  Returns:
    conditional predicate

### like

    public Predicate like(PredicateOperand pattern,
                          char escapeChar)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand satisfies the given pattern.

  Specified by:
    `like` in interface `PredicateOperand`
  Returns:
    conditional predicate

### like

    public Predicate like(String pattern)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand satisfies the given pattern.

  Specified by:
    `like` in interface `PredicateOperand`
  Returns:
    conditional predicate

### like

    public Predicate like(String pattern,
                          PredicateOperand escapeChar)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand satisfies the given pattern.

  Specified by:
    `like` in interface `PredicateOperand`
  Returns:
    conditional predicate

### like

    public Predicate like(String pattern,
                          char escChar)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing whether the PredicateOperand satisfies the given pattern.

  Specified by:
    `like` in interface `PredicateOperand`
  Returns:
    conditional predicate

### notEqual

    public Predicate notEqual(PredicateOperand arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing inequality with the specified argument.

  Specified by:
    `notEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - PredicateOperand instance or parameter
  Returns:
    conditional predicate

### notEqual

    public Predicate notEqual(Class cls)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing inequality with the specified argument.

  Specified by:
    `notEqual` in interface `PredicateOperand`
  Parameters:
    `cls` - - entity class
  Returns:
    conditional predicate

### notEqual

    public Predicate notEqual(Number arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing inequality with the specified argument.

  Specified by:
    `notEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - numberic value
  Returns:
    conditional predicate

### notEqual

    public Predicate notEqual(String arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing inequality with the specified argument.

  Specified by:
    `notEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - string value
  Returns:
    conditional predicate

### notEqual

    public Predicate notEqual(boolean arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing inequality with the specified argument.

  Specified by:
    `notEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - boolean value
  Returns:
    conditional predicate

### notEqual

    public Predicate notEqual(Date arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing inequality with the specified argument.

  Specified by:
    `notEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - date
  Returns:
    conditional predicate

### notEqual

    public Predicate notEqual(Calendar arg)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing inequality with the specified argument.

  Specified by:
    `notEqual` in interface `PredicateOperand`
  Parameters:
    `arg` - - calendar
  Returns:
    conditional predicate

### notEqual

    public Predicate notEqual(Enum<?> e)

  Description copied from interface: `PredicateOperand`
  Create a predicate for testing inequality with the specified argument.

  Specified by:
    `notEqual` in interface `PredicateOperand`
  Parameters:
    `e` - - enum
  Returns:
    conditional predicate

### getAliasHint

    public String getAliasHint(AliasContext ctx)

  Description copied from interface: `Visitable`
  Gets the hint to be used while creating alias.

  Specified by:
    `getAliasHint` in interface `Visitable`
  Overrides:
    `getAliasHint` in class `AbstractVisitable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 Apache Software Foundation. All Rights Reserved.